var TAG = "listener";

var censored_cache = new Map();

var context_requests = [];

var do_cache = true;

var current_tab_id = null;

const names = ["BELLYEXPOSED",
	"BELLYCOVERED",
	"BUTTOCKSEXPOSED",
	"BUTTOCKSCOVERED",
	"FEMALEBREASTEXPOSED",
	"FEMALEBREASTCOVERED",
	"FEMALEGENITALIAEXPOSED",
	"FEMALEGENITALIACOVERED",
	"MALEGENITALIACOVERED",
	"MALEGENITALIAEXPOSED",
	"MALEBREASTEXPOSED",
	"MALEBREASTCOVERED",
	"FACEFEMALE",
	"FACEMALE",
	"FEETCOVERED",
	"FEETEXPOSED",
	"ARMPITSCOVERED",
	"ARMPITSEXPOSED",
	"ANUSCOVERED",
	"ANUSEXPOSED"]

/**********************************************************************************************************************
 * OPTIONS
 **********************************************************************************************************************/
browser.runtime.onMessage.addListener(handleMessage);

function handleMessage(request, sender, sendResponse) {
	if(request.getdata){
		sendData(sendResponse);
		return true;
	}
	if(request.clearcache){
		censored_cache = new Map();
	}
	if(request.options){
		updateOptions(false);
	}
	if(request.logout){
		logout();
	}
	if(request.login){
		login(request.username, request.password, sendResponse);
		return true;
	}
}
function sendData(sendResponse) {
	sendResponse({
		cache: censored_cache,
		queue: queue
	});
}

var extension_active = true;

var labels = null;

var censor_type = null;

var file_types = null;

let bar_color = null;

function initializeOptions(){
	let options_request = browser.storage.sync.get(['active','labels','censor_type','file_types','debug','do_cache',
		'bar_configuration','blur_configuration','pixel_configuration','gif_configuration']);
	options_request.then((res) => {

		// Debugging
		if(res.debug != null){
			debug = res.debug;
		}else{
			debug = false;
			browser.storage.sync.set({
				debug: false,
			});
		}

		//Cache
		if(res.do_cache != null){
			do_cache = res.do_cache;
		}else{
			do_cache = true;
			browser.storage.sync.set({
				do_cache: true,
			});
		}

		// Active
		if(res.active != null){
			extension_active = res.active;
		}else{
			extension_active = true;
			browser.storage.sync.set({
				active: true,
			});
		}
		// Labels
		if(res.labels != null){
			labels = res.labels;
		}else{
			labels = ["BELLYEXPOSED",
				"BELLYCOVERED",
				"BUTTOCKSEXPOSED",
				"BUTTOCKSCOVERED",
				"FEMALEBREASTEXPOSED",
				"FEMALEBREASTCOVERED",
				"FEMALEGENITALIAEXPOSED",
				"FEMALEGENITALIACOVERED",
				"MALEGENITALIACOVERED",
				"MALEGENITALIAEXPOSED",
				"MALEBREASTEXPOSED",
				"MALEBREASTCOVERED",
				"FEETCOVERED",
				"FEETEXPOSED",
				"ARMPITSCOVERED",
				"ARMPITSEXPOSED",
				"ANUSCOVERED",
				"ANUSEXPOSED"];
			browser.storage.sync.set({
				labels: labels
			});
		}
		// Censor Type
		if(res.censor_type != null){
			censor_type = res.censor_type;
		}else{
			censor_type = 'black';
			browser.storage.sync.set({
				censor_type: 'black'
			});
		}
		// File Types
		if(res.file_types != null){
			file_types = res.file_types;
		}else{
			file_types = ['jpg','png','bmp','webp'];
			browser.storage.sync.set({
				file_types: ['jpg','png','bmp','webp']
			});
		}

		// Bar Color
		if(res.bar_color != null){
			bar_color =  hexConverter(res.bar_color) || hexConverter('#000000');
		}else{
			bar_color = hexConverter('#000000');
			browser.storage.sync.set({
				bar_color: bar_color
			});
		}

		// CensorType Configuration
		if(res.blur_configuration != null){
			blur_configuration = res.blur_configuration;
		}else{
			browser.storage.sync.set({
				blur_configuration: default_blur_configuration,
			});
		}
		if(res.pixel_configuration != null){
			pixel_configuration = res.pixel_configuration;
		}else{
			browser.storage.sync.set({
				pixel_configuration: default_pixel_configuration,
			});
		}
		if(res.bar_configuration != null){
			bar_configuration = res.bar_configuration;
		}else{
			browser.storage.sync.set({
				bar_configuration: default_bar_configuration,
			});
		}
		if(res.gif_configuration != null){
			gif_configuration = res.gif_configuration;
		}else{
			browser.storage.sync.set({
				gif_configuration: default_gif_configuration,
			});
		}
		repairConfigurations();

		refreshLogin();
	});
}

function updateOptions(startup){
	let options_request = browser.storage.sync.get(['active','labels','censor_type','file_types','bar_color','debug',
		'do_cache','bar_configuration','blur_configuration','pixel_configuration','gif_configuration']);
	options_request.then((res) => {

		debug = res.debug || false;
		if(extension_active !== res.active || startup){
			browser.browsingData.remove({},
				{
					cache: true,
				});
			log("Cache cleared");
		}

		extension_active = res.active;
		labels = res.labels || [];
		censor_type = res.censor_type || 'black';
		file_types = res.file_types || ['jpg','png','bmp','webp']
		bar_color =  hexConverter(res.bar_color) || hexConverter('#000000');
		do_cache = res.do_cache;
		blur_configuration  = res.blur_configuration  	|| default_blur_configuration;
		bar_configuration   = res.bar_configuration   	|| default_bar_configuration;
		pixel_configuration = res.pixel_configuration 	|| default_pixel_configuration;
		gif_configuration 	= res.gif_configuration 	|| default_gif_configuration;
		/*
		log(do_cache);
		log(bar_color);
		log(file_types);
		log(censor_type);
		log(labels);
		*/
	});
}
initializeOptions();

function hexConverter(hex) {
 return hex.replace('#','0xFF');
}
/**********************************************************************************************************************/


/**********************************************************************************************************************
 * AI
 **********************************************************************************************************************/
const [modelWeight, modelHeight] = [320, 320];
const weights = browser.runtime.getURL("web_model/model.json");
var model = null;
tf.loadGraphModel(weights).then(model_await => {
	model = model_await;
	//Warmup
	const dummy  = tf.zeros([1, 320, 320, 3], 'float32');
	return model.executeAsync( dummy ).then(function(result){
		dummy.dispose();
		log("Model LOADED");
		return result;
	});



});

browser.webRequest.onBeforeRequest.addListener(
    blockImages,
    {urls: ["<all_urls>"], types:["image","imageset","media","main_frame"]},
    ["blocking"]
);

browser.tabs.onRemoved.addListener(handleRemoved);

function handleRemoved(tabId, removeInfo) {
  log("Tab: " + tabId + " is closing");
  log("Window ID: " + removeInfo.windowId);
  log("Window is closing: " + removeInfo.isWindowClosing);
  log("queue length before: ", queue.length);
  queue.forEach(function (item, index, object) {
	if(item.tabId == tabId){
		object.splice(index, 1);
		log('Removed from queue', object);
	}
  });
  log("Queue length after: ", queue.length);
  
}

browser.tabs.onUpdated.addListener(handleUpdated);

function handleUpdated(tabId, changeInfo, tabInfo) {
  log("Updated tab: " + tabId);
  log("Changed attributes: ");
  log(changeInfo);
  log("New tab Info: ");
  log(tabInfo);
  if(tabInfo.active){
	  if(current_tab_id != tabInfo.id){
		  current_tab_id = tabInfo.id;
		  log("current_tab_id",current_tab_id);
		  queue.sort( compareCensorRequest );
	  }
  }

  // What if we open a new web-page but there are ongion requests
	// This is bugged
  /*
  queue.forEach(function (item, index, object) {
	if(item.tabId == tabId && item.originUrl != tabInfo.url){
		object.splice(index, 1);
		log("Removing ",tabId, item.originUrl, tabInfo);
	}
  });
  */

}


browser.webRequest.onHeadersReceived.addListener(
	uncache,
	{urls: ["<all_urls>"], types:["image","imageset","media","main_frame"]}, //"main_frame"
	["blocking", "responseHeaders"]
);

function uncache(e) {
		if(!extension_active){
			return;
		}
		log("UNCACHING:", e);
		var asyncCacheControl = new Promise((resolve, reject) => {
			for (var i = e.responseHeaders.length - 1; i >= 0; --i) {
				if (e.responseHeaders[i].name == "Cache-Control") {
					e.responseHeaders.splice(i, 1);
				}
			}
			var cacheControl = {
				name: "Cache-Control",
				value: "no-cache, no-store, must-revalidate"
			};
			e.responseHeaders.push(cacheControl);
			resolve({responseHeaders: e.responseHeaders});
		});
		return asyncCacheControl;
}


function compareCensorRequest( a, b ) {
	/*
	if(a.tabId != current_tab_id){
		return 1;
	}
	*/
	if ( a.tabId != b.tabId){
		if(a.tabId == current_tab_id){
			//log("Sortiere a nach vorne weil current ", a.tabId, "current = ", current_tab_id);
			return -1;
		}
		if(b.tabId == current_tab_id){
			//log("Sortiere a nach vorne weil nicht current", a.tabId, "current = ", current_tab_id);
			return 1;
		}
	}
    if ( a.img_dimension > b.img_dimension ){
		//log("Sortiere größeres Biild nach vorne");
    	return -1;
    }
    if ( a.img_dimension < b.img_dimension ){
		//log("Sortiere kleines Bild nach hinten");
    	return 1;
    }
    return 0;
}

function blockImages(requestDetails) {
	if(!extension_active){
		return {};
	}
	let str = requestDetails.url.substring(0, requestDetails.url.length - 4);
	let pathArray = requestDetails.url.split( '/' );
	let protocol = pathArray[0];
	let host = pathArray[2];
	let favicon_url = protocol + '//' + host + '/favicon';
	if(favicon_url === str){
		return {};
	}
	let filter = browser.webRequest.filterResponseData(requestDetails.requestId);

	filter.onerror = event => {
		log(`Error: ${filter.error}`);
	}
	let stream = [];
	let promise;
	filter.onstart = event => {
		promise = new Promise((ai_resolve, ai_reject) => {
			toDataURL(requestDetails.url, function (imgdata, contenttype) {
				if(!processableContentType(contenttype)){
					if(contenttype === 'application/xml'){
						filter.dispose();
						return {};
					}
					ai_reject("rejected by contenttype " + contenttype);
					return {};
				}
				let crf = context_requests.filter(e => e.url === requestDetails.url);
				if(do_cache && contenttype !== "image/gif"){
					let cache_url = requestDetails.url;
					if(crf.length > 0){
						cache_url = crf[0].originalUrl;
					}
					let cached_result = censored_cache.get(cache_url);
					let censor_type_local = censor_type;
					if(crf.length > 0){
						censor_type_local = crf[0].censor_type;
					}
					if (cached_result) {
						handleCache(cached_result, requestDetails, filter, censor_type_local);
						ai_resolve();
						return {};
					}
				}
				let blob = new Blob([imgdata], {type: contenttype});
				let filename = requestDetails.url.split('/').pop();
				let file = new File([blob], filename);
				let censor_type_processed = censor_type;
				if(crf.length > 0){
					censor_type_processed = crf[0].censor_type;
				}
				context_requests = context_requests.filter(e => e.url !== requestDetails.url);
				if ((!gif_configuration._thumbnails || crf.length > 0) && contenttype === "image/gif" &&
					(file_types.includes('gif') || crf.length > 0)
				) {
					if(user != null && user.permissions.permission_file_type_gif){
						if(gif_configuration._memory_method > 0){
							log("processGIFMem (fast)");
							processGIFMem(requestDetails, blob, filter, censor_type_processed);
						}else{
							log("processGIF");
							processGIF(requestDetails, blob, filter, censor_type_processed);
						}
					}else{
						ai_reject("No permissions for GIF or user object not established");
					}
				} else {
					checkMime(file, function (type, ext, header, cont) {
						if (!cont && crf.length == 0) {
							ai_reject("rejected by mime"+requestDetails.url);
							return {};
						}
						processImage(requestDetails, blob, file, imgdata, filename, contenttype, ext, header, filter, censor_type_processed).then(r => {
							return r
						}).catch(e => {
							ai_reject("error in processImage");
						});
						return {};
					});
				}
			});
		});
		promise.catch((e) => {
			log("Error: ", e);
			promise.error = true;
		});

	}

	filter.ondata = event => {
		stream.push(event.data);
	}

	filter.onstop  = event => {
		if (promise && promise.error) {
			log("Handling error by writing original data stream");
			for (let data of stream) {
				filter.write(data);
			}
			filter.disconnect();
		}else{
			promise.catch((e) => {
				log("Handling error by writing original data stream", e);
				for (let data of stream) {
					filter.write(data);
				}
				filter.disconnect();
			});
		}


	}

}



function handleCache(cached_result, requestDetails, filter, censor_type_local = null){
		log("This request was loaded from cache: ", cached_result);
		if(
			cached_result.censortype == censor_type &&
			cached_result.labels.length === labels.length &&
			cached_result.labels.every(function(value, index) { return value === labels[index]})
		){
			//This is for future purpose
			cached_result.load_from_cache = true;
		}else{
			cached_result.load_from_cache = false;
		}
		//New options to apply:
		if(censor_type_local == null){
			cached_result.censortype = censor_type;
		}else{
			cached_result.censortype = censor_type_local;
		}

		cached_result.labels = labels;
		applyFilter(requestDetails, cached_result, filter);
}


function toDataURL(url, callback) {
  var xhr1 = new XMLHttpRequest();
  var ct = "";
  function hand () {
		ct = this.getResponseHeader('content-type');
  }
  xhr1.onreadystatechange = hand;
  xhr1.onload = function() {
    var reader = new FileReader();
    reader.onloadend = function() {
      callback(reader.result, ct);
    }
    reader.readAsArrayBuffer(xhr1.response);
  };
  xhr1.open('GET', url);
  xhr1.responseType = 'blob';
  xhr1.send();
}

function checkMime(file, callback){
	let fileReader = new FileReader();
    fileReader.onloadend = function(e) {
		let arr = (new Uint8Array(e.target.result)).subarray(0, 4);
		let header = '';
        for (var i = 0; i < arr.length; i++) {
            header += arr[i].toString(16);
        }

        // Check the file signature against known types
        let type = 'unknown';
		let ext = '';

        switch (header) {
            case '89504e47':
                type = 'image/png';
				ext = 'png';
				callback(type, ext, header, file_types.includes(ext));
				return;
                break;
            case '47494638':
                type = 'image/gif';
				ext = 'gif';
                callback(type, ext, header, file_types.includes(ext) || gif_configuration._thumbnails);
				return;
                break;
			case '52494646':
				type = 'image/webp';
				ext = 'webp';
				callback(type, ext, header, file_types.includes(ext));
				return;
				break;
            case 'ffd8ffe0':
                type = 'jpg';
                ext = 'jpg';
                callback(type, ext, header, file_types.includes(ext));
                return;
                break;
            case 'ffd8ffe1':
                type = 'jpg';
                ext = 'jpg';
                callback(type, ext, header, file_types.includes(ext));
                return;
                break;
            case 'ffd8ffe2':
                type = 'image/jpeg';
				ext = 'jpg';
				callback(type, ext, header, file_types.includes(ext));
				return;
                break;
            case 'ffd8ffdb':
                type = 'image/jpeg';
                ext = 'jpg';
                callback(type, ext, header, file_types.includes(ext));
                return;
                break;
			case '1a45dfa3':
				type = 'video/webm';
				ext = 'webm';
				//callback(type, ext, header, true);
				//return;
				break;
            case '25504446':
                type = 'application/pdf';
				ext = 'pdf';
                break;
        }
        if(header.startsWith("424d")){
            type = 'image/bmp';
            ext = 'bmp';
            callback(type, ext, header, file_types.includes(ext));
			return;
        }
        /*
        if (file.type !== type) {
			//log('Mime type detected: ' + type + '. Does not match file extension.');
        } else {
			//log('Mime type detected: ' + type + '. Matches file extension.');
        }
        */
		callback(type, ext, header, false);
    };
    fileReader.readAsArrayBuffer(file);
}

function processableContentType(content_type){
	/*
	if (content_type !== "image/png" && content_type !== "image/jpg" && content_type !== "image/jpeg" &&
		content_type !== "image/webp" && content_type !== "image/bmp" && content_type !== "image/gif" &&
		content_type !== "video/webm") {
		return false;
	}
	return true;
	*/
	if(content_type === "image/png" && file_types.includes('png')){
		return true;
	}
	if(content_type === "image/jpg" && file_types.includes('jpg')){
		return true;
	}
	if(content_type === "image/jpeg" && file_types.includes('jpg')){
		return true;
	}
	if(content_type === "image/webp" && file_types.includes('webp')){
		return true;
	}
	if(content_type === "image/bmp" && file_types.includes('bmp')){
		return true;
	}
	if(content_type === "image/gif" && file_types.includes('gif')){
		return true;
	}
	if(content_type === "video/webm" && file_types.includes('webm')){
		return false;
	}
	return false;
}

function processGIF(requestDetails, blob, filter, censor_type_local = null){
	//Queue.enqueue(() => new Promise((qresolve, reject) =>
	//{
	if(censor_type_local == null){
		censor_type_local = censor_type;
	}
	let t0 = performance.now();
	blob.arrayBuffer().then(buffer => {
		let gif = window.gifuct.parseGIF(buffer);
		let frames = window.gifuct.decompressFrames(gif, true);
		let gif_encoder = new GIF({
			workers: 2,
			quality: 10,
			debug: debug,
			//background: '#fff',
			//transparent: 'rgba(0,0,0,255)',
			//transparent: 0,
		});
		let gifpromises = [];
		let last_frame = null;
		let transparency_set = false;
		let gif_base_width = null;
		let gif_base_height = null;
		frames.forEach(function(element, idx, array){
			if(idx === 0){
				gif_base_width = element.dims.width;
				gif_base_height = element.dims.height;
				gif_encoder.setOption('width', gif_base_width);
				gif_encoder.setOption('height', gif_base_height);
				log("GIF ENC Initialised");

				/* return a single frame
                var tempCanvas = document.createElement('canvas');
                tempCanvas.width = element.dims.width;
                tempCanvas.height = element.dims.height;
                var tempCtx = tempCanvas.getContext('2d');
                var frameImageData = tempCtx.createImageData(element.dims.width, element.dims.height);
                frameImageData.data.set(element.patch);
                tempCtx.putImageData(frameImageData, 0, 0);
                tempCanvas.toBlob(function(blob) {
                    var reader  = new FileReader();
                    reader.onloadend = function () {
                        resolve({redirectUrl: reader.result});
                    }
                    reader.readAsDataURL(blob);
                });
                return;
                */
			}
			if(element.disposalType > 1 && !transparency_set && 'transparentIndex' in element){
				gif_encoder.setOption('transparent', 'rgba(0,0,0,${element.transparentIndex})');
				transparency_set = true;
			}

						//log("frames", element);
						let tempCanvas = document.createElement('canvas');
						let tempCtx = tempCanvas.getContext('2d');
						tempCanvas.width = gif_base_width;//element.dims.width;
						tempCanvas.height = gif_base_height;//element.dims.height;
						//tempCanvas.width = element.dims.width;
						//tempCanvas.height = element.dims.height;

						//var naturalHeight = element.dims.height;
						//var naturalWidth = element.dims.width;
						let frameImageData = tempCtx.createImageData(element.dims.width, element.dims.height);
						//let frameImageData = tempCtx.createImageData(gif_base_width, gif_base_height);

						//let dif_width = Math.max(gif_base_width-element.dims.width, 0);
						//let dif_height = Math.max(gif_base_height-element.dims.height, 0);

						if(element.disposalType <= 1 && 'transparentIndex' in element && last_frame){
							//frameImageData.data.set(last_frame.patch);
							//frameImageData = last_frame;

							frameImageData.data.set(element.patch);

							tempCtx.putImageData(frameImageData, element.dims.left, element.dims.top,0,0,element.dims.width, element.dims.height);
							let correctedFrameImageData = tempCtx.getImageData(0, 0, gif_base_width, gif_base_height);

							frameImageData = mergeImageData([last_frame, correctedFrameImageData]);
							//tempCtx.putImageData(frameImageData, element.dims.left, element.dims.top,0,0, element.dims.width, element.dims.height);
							tempCtx.putImageData(frameImageData, 0,0);
						}else{
							frameImageData.data.set(element.patch);
							tempCtx.putImageData(frameImageData, element.dims.left, element.dims.top,0,0, element.dims.width, element.dims.height);
						}
						last_frame = tempCtx.getImageData(0,0,gif_base_width, gif_base_height);
						//const input = tf.image.resizeBilinear(tf.browser.fromPixels(tempCanvas), [modelWeight, modelHeight]).div(255.0).expandDims(0);
						const fromPixels = tf.browser.fromPixels(tempCanvas);
						const resized = tf.image.resizeBilinear(fromPixels, [modelWeight, modelHeight]);
						const divved = resized.div(255.0);
						const input = divved.expandDims(0);
						fromPixels.dispose();
						resized.dispose();
						divved.dispose();
			let promise = //new Promise(function(resolve, reject) {
				Queue.enqueue(() => new Promise((resolve, reject) => {
						model.executeAsync(input).then(res => {
							const [boxes, scores, classes, valid_detections] = res;
							let valid_detections_sync =  valid_detections.dataSync();
							let classes_sync =  classes.dataSync();
							let boxes_sync =  boxes.dataSync();
							let scores_sync =  scores.dataSync();
							valid_detections.dispose();
							classes.dispose();
							scores.dispose();
							boxes.dispose();
							let marvinImage = new MarvinImage();
							tempCanvas.toBlob(function(blob) {
								let urlCreator = window.URL || window.webkitURL;
								let marvinUrl = urlCreator.createObjectURL(blob);
								marvinImage.load(marvinUrl, function () {
									let processedRequest = new ProcessedCensorRequest(requestDetails.url, blob, gif_base_width, gif_base_height, 'image/gif',
										boxes_sync, scores_sync, classes_sync, valid_detections_sync,
										censor_type_local, labels);
									paintCensor(marvinImage, requestDetails, processedRequest);
									tempCtx.putImageData(marvinImage.imageData, 0, 0);
									resolve(
										{
											frame: idx,
											delay: element.delay? element.delay : 100,
											disposalType: element.disposalType,
											processedData: tempCtx
										});

								});

							});
						}).catch(function(err) {
							log("gif error",err);
							resolve(
								{
									frame: idx,
									delay: element.delay,
									disposalType: element.disposalType,
									processedData: tempCtx
								}
							);
						}).finally(fin => {
							input.dispose();
							log('Tensorcount:', tf.memory().numTensors);
						});

					}), requestDetails.tabId, requestDetails.originUrl, requestDetails.url, blob, gif_base_width, gif_base_height);
			gifpromises.push(promise);
		});

		Promise.allSettled(gifpromises).
		then((results) => results.forEach(
			(result) => {
				gif_encoder.addFrame(result.value.processedData, {delay: result.value.delay, dispose: result.value.disposalType });
			}
		)).finally(function(err) {
			gif_encoder.on('finished', function(blob) {
				blob.arrayBuffer().then(buffer => {
					let t1 = performance.now();
					log("Processing GIF time " + (t1 - t0) + " millisseconds.");
					try {
						filter.write(buffer);
						filter.close();
						//resolve();
					} catch (err) {
						log('Caught ' + err, buffer);
					}
				});
			});
			gif_encoder.render();

		});
	});
	//}), requestDetails.tabId, requestDetails.originUrl, requestDetails.url, blob, 9999
	//);

}

function processGIFMem(requestDetails, blob, filter, censor_type_local = null){
	Queue.enqueue(() => new Promise((resolve, reject) =>
		{
			if(censor_type_local == null){
				censor_type_local = censor_type;
			}
			let t0 = performance.now();
			blob.arrayBuffer().then(buffer => {
				let gif = window.gifuct.parseGIF(buffer);
				let frames = window.gifuct.decompressFrames(gif, true);
				let gif_encoder = new GIF({
					workers: 2,
					quality: 10,
					debug: debug,
					//background: '#fff',
					//transparent: 'rgba(0,0,0,255)',
					//transparent: 0,
				});
				let gifpromises = [];
				let last_frame = null;
				let transparency_set = false;
				let gif_base_width = null;
				let gif_base_height = null;
				frames.forEach(function(element, idx, array){
					if(idx === 0){
						gif_base_width = element.dims.width;
						gif_base_height = element.dims.height;
						gif_encoder.setOption('width', gif_base_width);
						gif_encoder.setOption('height', gif_base_height);
						log("GIF ENC Initialised");

						/* return a single frame
						var tempCanvas = document.createElement('canvas');
						tempCanvas.width = element.dims.width;
						tempCanvas.height = element.dims.height;
						var tempCtx = tempCanvas.getContext('2d');
						var frameImageData = tempCtx.createImageData(element.dims.width, element.dims.height);
						frameImageData.data.set(element.patch);
						tempCtx.putImageData(frameImageData, 0, 0);
						tempCanvas.toBlob(function(blob) {
							var reader  = new FileReader();
							reader.onloadend = function () {
								resolve({redirectUrl: reader.result});
							}
							reader.readAsDataURL(blob);
						});
						return;
						*/
					}
					if(element.disposalType > 1 && !transparency_set && 'transparentIndex' in element){
						gif_encoder.setOption('transparent', 'rgba(0,0,0,${element.transparentIndex})');
						transparency_set = true;
					}
					let promise = new Promise(function(resolve, reject) {
						//log("frames", element);
						let tempCanvas = document.createElement('canvas');
						let tempCtx = tempCanvas.getContext('2d');
						tempCanvas.width = gif_base_width;//element.dims.width;
						tempCanvas.height = gif_base_height;//element.dims.height;
						//tempCanvas.width = element.dims.width;
						//tempCanvas.height = element.dims.height;

						//var naturalHeight = element.dims.height;
						//var naturalWidth = element.dims.width;
						let frameImageData = tempCtx.createImageData(element.dims.width, element.dims.height);
						//let frameImageData = tempCtx.createImageData(gif_base_width, gif_base_height);

						//let dif_width = Math.max(gif_base_width-element.dims.width, 0);
						//let dif_height = Math.max(gif_base_height-element.dims.height, 0);

						if(element.disposalType <= 1 && 'transparentIndex' in element && last_frame){
							//frameImageData.data.set(last_frame.patch);
							//frameImageData = last_frame;

							frameImageData.data.set(element.patch);

							tempCtx.putImageData(frameImageData, element.dims.left, element.dims.top,0,0,element.dims.width, element.dims.height);
							let correctedFrameImageData = tempCtx.getImageData(0, 0, gif_base_width, gif_base_height);

							frameImageData = mergeImageData([last_frame, correctedFrameImageData]);
							//tempCtx.putImageData(frameImageData, element.dims.left, element.dims.top,0,0, element.dims.width, element.dims.height);
							tempCtx.putImageData(frameImageData, 0,0);
						}else{
							frameImageData.data.set(element.patch);
							tempCtx.putImageData(frameImageData, element.dims.left, element.dims.top,0,0, element.dims.width, element.dims.height);
						}
						last_frame = tempCtx.getImageData(0,0,gif_base_width, gif_base_height);
						//const input = tf.image.resizeBilinear(tf.browser.fromPixels(tempCanvas), [modelWeight, modelHeight]).div(255.0).expandDims(0);
						const fromPixels = tf.browser.fromPixels(tempCanvas);
						const resized = tf.image.resizeBilinear(fromPixels, [modelWeight, modelHeight]);
						const divved = resized.div(255.0);
						const input = divved.expandDims(0);
						fromPixels.dispose();
						resized.dispose();
						divved.dispose();
						log('Tensorcount:', tf.memory().numTensors);
						model.executeAsync(input).then(res => {
							input.dispose();
							const [boxes, scores, classes, valid_detections] = res;
							let valid_detections_sync =  valid_detections.dataSync();
							let classes_sync =  classes.dataSync();
							let boxes_sync =  boxes.dataSync();
							let scores_sync =  scores.dataSync();
							valid_detections.dispose();
							classes.dispose();
							scores.dispose();
							boxes.dispose();
							let marvinImage = new MarvinImage();
							tempCanvas.toBlob(function(blob) {
								let urlCreator = window.URL || window.webkitURL;
								let marvinUrl = urlCreator.createObjectURL(blob);
								marvinImage.load(marvinUrl, function () {
									let processedRequest = new ProcessedCensorRequest(requestDetails.url, blob, gif_base_width, gif_base_height, 'image/gif',
										boxes_sync, scores_sync, classes_sync, valid_detections_sync,
										censor_type_local, labels);
									paintCensor(marvinImage, requestDetails, processedRequest);
									tempCtx.putImageData(marvinImage.imageData, 0, 0);
									resolve(
										{
											frame: idx,
											delay: element.delay? element.delay : 100,
											disposalType: element.disposalType,
											processedData: tempCtx
										});
								});
							});
						}).catch(function(err) {
							log("gif error",err);
							resolve(
								{
									frame: idx,
									delay: element.delay,
									disposalType: element.disposalType,
									processedData: tempCtx
								}
							);
						});

					});
					gifpromises.push(promise);
			});

			Promise.allSettled(gifpromises).
			then((results) => results.forEach(
				(result) => {
					gif_encoder.addFrame(result.value.processedData, {delay: result.value.delay, dispose: result.value.disposalType });
				}
			)).finally(function(err) {
				gif_encoder.on('finished', function(blob) {
					blob.arrayBuffer().then(buffer => {
						let t1 = performance.now();
						log("Processing time " + (t1 - t0) + " millisseconds.");
						try {
							filter.write(buffer);
							filter.close();
							resolve();
						} catch (err) {
							log('Caught ' + err, buffer);
						}
					});
				});
				gif_encoder.render();

			});


		});
		}), requestDetails.tabId, requestDetails.originUrl, requestDetails.url, blob, 9999
	);

}

function mergeImageData( imageDataArray ) {

	let newImageData = imageDataArray[ 0 ];

	for ( let j = 0; j < imageDataArray.length; j++ ) { // iterate through the imageDataArray

		for ( let i = 0, bytes = imageDataArray[ j ].data.length; i < bytes; i += 4 ) { // iterate through image bytes

			let index = ( imageDataArray[ j ].data[ i + 3 ] === 0 ? 0 : j );

			newImageData.data[ i ] = imageDataArray[ index ].data[ i ];
			newImageData.data[ i + 1 ] = imageDataArray[ index ].data[ i + 1 ];
			newImageData.data[ i + 2 ] = imageDataArray[ index ].data[ i + 2 ];
			newImageData.data[ i + 3 ] = imageDataArray[ index ].data[ i + 3 ];
		}
	}
	return newImageData;
};

function processImage(requestDetails, blob, file, imgdata, filename, contenttype, ext, header, filter, censor_type_local = null){
	return new Promise((resolve, reject) => {
		if(!filename.endsWith("."+ext)){
			filename += "."+ext;
			file = new File([blob], filename);
		}
		if(file.size < 1000){ // = < 50 kb
			log("rejected by filesize",file.size);
			filter.disconnect();
			resolve({});
			return;
		}
		if(censor_type_local == null){
			censor_type_local = censor_type;
		}
		let urlCreator = window.URL || window.webkitURL;
		let imageUrl = urlCreator.createObjectURL(blob);
		let c = document.createElement('img');
		c.src = imageUrl;
		let imageData = new Image();
		imageData.onload = function () {
			let naturalWidth = this.naturalWidth;
			let naturalHeight = this.naturalHeight;
			if(this.naturalWidth < 51 || this.naturalHeight < 51){
				filter.disconnect();
				resolve({});
				return;
			}
			let img_dimension = this.naturalWidth*this.naturalHeight;
			Queue.enqueue(
				() => new Promise((resolve, reject) => {
					//const input = tf.image.resizeBilinear(tf.browser.fromPixels(c), [modelWeight, modelHeight]).div(255.0).expandDims(0);
					const fromPixels = tf.browser.fromPixels(c);
					const resized = tf.image.resizeBilinear(fromPixels, [modelWeight, modelHeight]);
					const divved = resized.div(255.0);
					const input = divved.expandDims(0);
					model.executeAsync(input).then(res => {
							const [boxes, scores, classes, valid_detections] = res;
							let valid_detections_sync =  valid_detections.dataSync();
							let classes_sync =  classes.dataSync();
							let boxes_sync =  boxes.dataSync();
							let scores_sync =  scores.dataSync();
							valid_detections.dispose();
							classes.dispose();
							scores.dispose();
							boxes.dispose();
							log(valid_detections_sync,classes_sync,boxes_sync,scores_sync);
							var processedRequest = new ProcessedCensorRequest(requestDetails.url, imgdata, naturalWidth, naturalHeight, contenttype,
								boxes_sync, scores_sync, classes_sync, valid_detections_sync,
								censor_type_local, labels);
							if (do_cache && !censored_cache.get(requestDetails.url)) {
								censored_cache.set(requestDetails.url, processedRequest);
							}
							applyFilter(requestDetails, processedRequest, filter)
								.catch(e => {
									reject('applyFilter filter error');
									return;
								});

						}).catch(e => {
							log(e.message)
							reject(e.message);
							return;
						}).finally(fin => {
							resized.dispose();
							divved.dispose();
							input.dispose();
							fromPixels.dispose();
							resolve({});
							return;
						});
					log('Tensorcount:', tf.memory().numTensors);
				}).catch(e => {
					log('Tensorflowerror outer catch', e, requestDetails.url);
					reject('Tensorflowerror outer catch');
				}).then((val) => resolve(val))
				, requestDetails.tabId, requestDetails.originUrl, requestDetails.url, imageData, img_dimension)
			queue.sort( compareCensorRequest );
		};
		imageData.src = imageUrl;

	});
}

function applyFilter(requestDetails, processedRequest, filter){
	let promise = new Promise((resolve, reject) => {
		let imgdata = processedRequest.imgdata;
		let contenttype = processedRequest.contenttype;
		let marvinImage = new MarvinImage();
		let urlCreator = window.URL || window.webkitURL;
		let blob = new Blob([imgdata], {type: contenttype});
		let marvinUrl = urlCreator.createObjectURL(blob);
		marvinImage.load(marvinUrl, function () {
			let t0 = performance.now();
			paintCensor(marvinImage, requestDetails, processedRequest);
			let t1 = performance.now();
			log("Processing time " + (t1 - t0) + " millisseconds.");
			let marvinBlob = marvinImage.toBlob();
			marvinBlob.arrayBuffer().then(buffer => {
				try {
					filter.write(buffer);
					filter.disconnect();
					resolve(buffer);
				} catch (err) {
					log('Caught ' + err, buffer);
					reject();
				}
			});
		});
	});
	return promise;
}


function paintCensor(marvinImage, requestDetails, processedRequest){
	let labels = processedRequest.labels;
	let valid_detections = processedRequest.valid_detections;
	let classes = processedRequest.classes;
	let scores = processedRequest.scores;
	let boxes = processedRequest.boxes;
	let naturalWidth = processedRequest.naturalWidth;
	let naturalHeight = processedRequest.naturalHeight;
	let censor_type = processedRequest.censortype;
	let censor_type_numeral = (censor_type == "black"? 3 : (censor_type == "pixel"? 1 : (censor_type == "blur"? 2 : (censor_type == "box"? 4 : 0))));

	log(
		"valid detections", valid_detections,
		"classes",classes,
		"boxes",boxes,
		"scores",scores);

	for (let i = 0; i < valid_detections[0]; ++i) {
		const klass = names[classes[i]];
		if(labels.includes(klass)) {
			let [x1, y1, x2, y2] = boxes.slice(i * 4, (i + 1) * 4);
			const score = scores[i].toFixed(2);
			x1 *= naturalWidth;
			x2 *= naturalWidth;
			y1 *= naturalHeight;
			y2 *= naturalHeight;
			let x = Math.ceil(x1);
			let y = Math.ceil(y1);
			let w = Math.ceil(x2 - x1);
			let h = Math.ceil(y2 - y1);
			switch (censor_type_numeral) {
				case 0:
					break;
				case 1:
					let wexp = Math.ceil(w*pixel_configuration._scale);
					let hexp = Math.ceil(h*pixel_configuration._scale);
					let xcor = Math.ceil(x-(wexp-w)/2);
					let ycor = Math.ceil(y-(hexp-h)/2);
					let distance = pixel_configuration._distance;
					let box_size = pixel_configuration._pixel_size;
					if(pixel_configuration._pixel_size_mode == 0){
						//box_size = Math.ceil(Math.sqrt(naturalHeight*naturalWidth)/100*pixel_configuration._pixel_size);
						box_size = Math.ceil(Math.min(naturalHeight,naturalWidth)/100*pixel_configuration._pixel_size);
						marvinImage = pixelRect(marvinImage, xcor, ycor, wexp, hexp, box_size, distance);
					}else{
						if(box_size < 5){
							marvinImage = pixelRectFast(marvinImage, xcor, ycor, wexp, hexp, box_size, distance);
						}else{
							marvinImage = pixelRect(marvinImage, xcor, ycor, wexp, hexp, box_size, distance);
						}
					}

					break;
				case 2:
					marvinImage = blurRect(marvinImage, x, y, w, h);
					break;
				case 3:
					marvinImage = blackBar(marvinImage, x, y, w, h);
					break;
				case 4:
					const font = "16px sans-serif";
					marvinImage.ctx.font = font;
					marvinImage.ctx.textBaseline = "top";
					marvinImage.ctx.strokeStyle = "#00FFFF";
					marvinImage.ctx.lineWidth = 4;
					marvinImage.ctx.strokeRect(x, y, w, h);
					marvinImage.ctx.fillStyle = "#00FFFF";
					const textWidth = marvinImage.ctx.measureText(klass + ":" + score).width;
					const textHeight = parseInt(font, 10); // base 10
					marvinImage.ctx.fillRect(x, y, textWidth + 4, textHeight + 4);
					marvinImage.ctx.fillStyle = "#000000";
					marvinImage.ctx.fillText(klass + ":" + score, x1, y1);
					marvinImage.imageData = marvinImage.ctx.getImageData(0, 0, naturalWidth, naturalHeight);
					break;
				//default:

			}
		}
	}
}