
function handleMessage(request, sender, sendResponse) {
    let timestamp = new Date().getTime();
    let queryString = "?t=" + timestamp;
    let newurl = request.reload + queryString
    $('img').each(function(i, obj) {
        if(obj.src === request.reload){
            sendResponse({add_context_request: newurl,
                add_context_request_original_url: request.reload
            });
            obj.src = newurl;
        }
    });
    $('source').each(function(i, obj) {
        if(obj.srcset === request.reload){
            sendResponse({add_context_request: newurl,
                          add_context_request_original_url: request.reload
            });
            obj.srcset = newurl;
        }
    });

}
browser.runtime.onMessage.addListener(handleMessage);


let initialized = false;

$(document).ready(function() {
    let video_overlay = browser.storage.sync.get('video_overlay');
    video_overlay.then((res) => {

        let use_overlay = res.video_overlay || false;
        if(use_overlay){
            if(!initialized){
                initialized = true;
                canvasScan();
            }
        }
    });
});


window.addEventListener('load', function () {
    let video_overlay = browser.storage.sync.get('video_overlay');
    video_overlay.then((res) => {
        console.log("video_overlay",res.video_overlay)
        let use_overlay = res.video_overlay || false;
        if(use_overlay){
            if(!initialized){
                initialized = true;
                canvasScan();
            }
        }
    });
})
/*
$(document).on ('mozfullscreenchange webkitfullscreenchange fullscreenchange',function(event){
    let target = event.target;
    if($(target).attr("puryfied")){
        let uuid = $(target).attr("puryfied");
        exitFullscreen();
        let canvas = $( 'canvas[puryfied="'+uuid+'"]' ).first();
        launchIntoFullscreen(canvas);
    }
});

function launchIntoFullscreen(element) {
    if (element.requestFullscreen) {
        element.requestFullscreen();
    } else if (element.mozRequestFullScreen) {
        element.mozRequestFullScreen();
    } else if (element.webkitRequestFullscreen) {
        element.webkitRequestFullscreen();
    } else if (element.msRequestFullscreen) {
        element.msRequestFullscreen();
    }
}

function exitFullscreen() {
    if (document.exitFullscreen) {
        document.exitFullscreen();
    } else if (document.mozCancelFullScreen) {
        document.mozCancelFullScreen();
    } else if (document.webkitExitFullscreen) {
        document.webkitExitFullscreen();
    }
}
*/
function canvasScan(){
    $( "canvas[puryfied]" ).each(function() {
        let uuid = $(this).attr('puryfied');
        let r = $( 'video[puryfied="'+uuid+'"]' );
        if(r.length == 0 || !r.is(':visible')){
            r.removeAttr('puryfied');
            $(this).remove();
        }
    });
    $( "video:not([puryfied])" ).each(function() {
        canvasCreate(this);
        return;
    });
    setTimeout(() => {
        canvasScan();
    }, 100);
}

function canvasCreate(video){
    let uuid = '_' + Math.random().toString(36).substr(2, 9)
    $( video ).attr('puryfied', uuid);
    $( video ).attr('controls', 'controls');
    let newCanvas = document.createElement("canvas");
    $( newCanvas ).attr('puryfied', uuid);
    $( video ).parent().prepend(newCanvas);

    const processor = {};

    processor.readjustSize = function readjustSize() {
        //var fullscreenElement = document.fullscreenElement || document.mozFullScreenElement ||
        //    document.webkitFullscreenElement || document.msFullscreenElement;
        //if(!fullscreenElement){
        let styles = document.defaultView.getComputedStyle(this.video, "");
        const cssText = Object.values(styles).reduce(
            (css, propertyName) =>
                `${css}${propertyName}:${styles.getPropertyValue(
                    propertyName
                )};`
        );
        this.c1.style.cssText = cssText;
        //}
        this.c1.style.pointerEvents = 'none';
        this.c1.style.position = 'absolute';
        this.c1.style.zIndex = '2147483647';

    }

    processor.doLoad = function doLoad(elem, c1) {
        this.latest_result = null;
        this.latest_result_frame = null;
        const video = elem;
        this.video = video;
        this.c1 = c1;
        this.ctx1 = this.c1.getContext('2d');
        this.readjustSize();

        video.addEventListener('play', () => {
            //this.width = video.videoWidth;
            //this.height = video.videoHeight;
            this.timerCallback();
        }, false);

        const isVideoPlaying = !!(video.currentTime > 0 && !video.paused && !video.ended && video.readyState > 2);

        if(!isVideoPlaying){
            this.timerCallback();
        }
    };

    processor.timerCallback = function timerCallback() {
        if (this.video.paused || this.video.ended) {
            return;
        }

        this.readjustSize();
        this.computeFrame().then(r => {
            setTimeout(() => {
                this.timerCallback();
            }, 0);
        });

    };

    processor.computeFrame = function computeFrame() {
        return new Promise((resolve, reject) => {
            this.c1.width = this.video.offsetWidth;
            this.c1.height = this.video.offsetHeight;
            let tempCanvas = document.createElement('canvas');
            tempCanvas.width = this.c1.width;
            tempCanvas.height = this.c1.height;
            let tempCtx = tempCanvas.getContext('2d');
            tempCtx.drawImage(this.video, 0, 0, this.video.offsetWidth, this.video.offsetHeight);
            let frame = tempCtx.getImageData(0, 0, this.video.offsetWidth, this.video.offsetHeight);

            if (this.latest_result != null) {
                //this.ctx1.drawImage(this.video, 0, 0, this.video.offsetWidth, this.video.offsetHeight);
                this.ctx1.putImageData(this.latest_result_frame, 0, 0);
                for (let i = 0; i < this.latest_result.valid_detections[0]; ++i) {
                    //const klass = names[this.latest_result.classes[i]];
                    //if(labels.includes(klass)) {
                    let [x1, y1, x2, y2] = this.latest_result.boxes.slice(i * 4, (i + 1) * 4);
                    const score = this.latest_result.scores[i].toFixed(2);
                    x1 *= this.c1.width;
                    x2 *= this.c1.width;
                    y1 *= this.c1.height;
                    y2 *= this.c1.height;
                    let x = Math.ceil(x1);
                    let y = Math.ceil(y1);
                    let w = Math.ceil(x2 - x1);
                    let h = Math.ceil(y2 - y1);
                    this.ctx1.fillRect(x, y, w, h);
                    // }
                }
            }
            let sending = browser.runtime.sendMessage({
                frame: frame,
                width: this.video.offsetWidth,
                height: this.video.offsetHeight
            });
            sending.then(response => {
                    let valid_detections = response.valid_detections;
                    let classes = response.classes;
                    let scores = response.scores;
                    let boxes = response.boxes;
                    this.latest_result = {
                        valid_detections: valid_detections,
                        classes: classes,
                        scores: scores,
                        boxes: boxes,
                    };
                    this.latest_result_frame = frame;
                }
                , handleError2).finally(fin => {
                resolve();
            });
        });
    };

    processor.doLoad(video, newCanvas);
}


const names = ["BELLYEXPOSED",
    "BELLYCOVERED",
    "BUTTOCKSEXPOSED",
    "BUTTOCKSCOVERED",
    "FEMALEBREASTEXPOSED",
    "FEMALEBREASTCOVERED",
    "FEMALEGENITALIAEXPOSED",
    "FEMALEGENITALIACOVERED",
    "MALEGENITALIACOVERED",
    "MALEGENITALIAEXPOSED",
    "MALEBREASTEXPOSED",
    "MALEBREASTCOVERED",
    "FACEFEMALE",
    "FACEMALE",
    "FEETCOVERED",
    "FEETEXPOSED",
    "ARMPITSCOVERED",
    "ARMPITSEXPOSED",
    "ANUSCOVERED",
    "ANUSEXPOSED"]



function handleError2(error) {
    console.log(`Error: ${error}`);
}

/*
function simulate(element, eventName)
{
    var options = extend(defaultOptions, arguments[2] || {});
    var oEvent, eventType = null;

    for (var name in eventMatchers)
    {
        if (eventMatchers[name].test(eventName)) { eventType = name; break; }
    }

    if (!eventType)
        throw new SyntaxError('Only HTMLEvents and MouseEvents interfaces are supported');

    if (document.createEvent)
    {
        oEvent = document.createEvent(eventType);
        if (eventType == 'HTMLEvents')
        {
            oEvent.initEvent(eventName, options.bubbles, options.cancelable);
        }
        else
        {
            oEvent.initMouseEvent(eventName, options.bubbles, options.cancelable, document.defaultView,
                options.button, options.pointerX, options.pointerY, options.pointerX, options.pointerY,
                options.ctrlKey, options.altKey, options.shiftKey, options.metaKey, options.button, element);
        }
        element.dispatchEvent(oEvent);
    }
    else
    {
        options.clientX = options.pointerX;
        options.clientY = options.pointerY;
        var evt = document.createEventObject();
        oEvent = extend(evt, options);
        element.fireEvent('on' + eventName, oEvent);
    }
    return element;
}

function extend(destination, source) {
    for (var property in source)
        destination[property] = source[property];
    return destination;
}

var eventMatchers = {
    'HTMLEvents': /^(?:load|unload|abort|error|select|change|submit|reset|focus|blur|resize|scroll)$/,
    'MouseEvents': /^(?:click|dblclick|mouse(?:down|up|over|move|out))$/
}
var defaultOptions = {
    pointerX: 0,
    pointerY: 0,
    button: 0,
    ctrlKey: false,
    altKey: false,
    shiftKey: false,
    metaKey: false,
    bubbles: true,
    cancelable: true
}
*/
