window.onload = function() {

	document.getElementById("blur").onclick = function (e) { 
	  browser.storage.sync.set({
		censor_type: 'blur'
	  }).then(function(){
		  updateOptionsContentScript();
	  });
	  document.getElementById("normal").classList.remove("selected");
	  document.getElementById("box").classList.remove("selected");
	  document.getElementById("blur").classList.add("selected");
	  document.getElementById("pixel").classList.remove("selected");
	  document.getElementById("black").classList.remove("selected");
	};

	document.getElementById("normal").onclick = function () {
		browser.storage.sync.set({
			censor_type: 'normal'
		}).then(function(){
			updateOptionsContentScript();
		});
		document.getElementById("normal").classList.add("selected");
		document.getElementById("box").classList.remove("selected");
		document.getElementById("blur").classList.remove("selected");
		document.getElementById("pixel").classList.remove("selected");
		document.getElementById("black").classList.remove("selected");
	};

	document.getElementById("box").onclick = function () {
		browser.storage.sync.set({
			censor_type: 'box'
		}).then(function(){
			updateOptionsContentScript();
		});
		document.getElementById("box").classList.add("selected");
		document.getElementById("normal").classList.remove("selected");
		document.getElementById("blur").classList.remove("selected");
		document.getElementById("pixel").classList.remove("selected");
		document.getElementById("black").classList.remove("selected");
	};

	document.getElementById("pixel").onclick = function () { 
	  browser.storage.sync.set({
		censor_type: 'pixel'
	  }).then(function(){
		  updateOptionsContentScript();
	  });
	  document.getElementById("pixel").classList.add("selected");
	  document.getElementById("normal").classList.remove("selected");
	  document.getElementById("box").classList.remove("selected");
	  document.getElementById("blur").classList.remove("selected");
	  document.getElementById("black").classList.remove("selected");
	};
	
	document.getElementById("black").onclick = function () { 
	  browser.storage.sync.set({
		censor_type: 'black'
	  }).then(function(){
		  updateOptionsContentScript();
	  });
	  document.getElementById("black").classList.add("selected");
	  document.getElementById("normal").classList.remove("selected");
	  document.getElementById("box").classList.remove("selected");
	  document.getElementById("blur").classList.remove("selected");
	  document.getElementById("pixel").classList.remove("selected");
	};

	$(".labelButton").on('click', function(event){
		$(this).toggleClass("selected");
		var labels = browser.storage.sync.get('labels');
		labels.then((res) => {
			labellist = res.labels || [];
			if($(this).hasClass("selected")){
				if(labellist.indexOf(this.id) === -1){
					labellist.push(this.id)
				}
			}else{
				if(labellist.indexOf(this.id) != -1){
					labellist = removeItemAll(labellist, this.id);
				}
			}
			browser.storage.sync.set({
				labels: labellist
			}).then(function(){
				updateOptionsContentScript();
			});
		});

	});
	$("#options").click(function(){
		browser.runtime.openOptionsPage();
		$("body").hide();
	});

};

function removeItemAll(arr, value) {
	var i = 0;
	while (i < arr.length) {
		if (arr[i] === value) {
			arr.splice(i, 1);
		} else {
			++i;
		}
	}
	return arr;
}

function restoreOptions() {
	restoreCensor_Type();
	restoreLabels();
}

function restoreCensor_Type() {
  var censor_type = browser.storage.sync.get('censor_type');
  censor_type.then((res) => {
  	document.getElementById("normal").classList.remove("selected");
  	document.getElementById("box").classList.remove("selected");
    document.getElementById("black").classList.remove("selected");
	document.getElementById("pixel").classList.remove("selected");
	document.getElementById("blur").classList.remove("selected");
	document.getElementById(""+res.censor_type).classList.add("selected");
  });

}
function restoreLabels() {
	var labels = browser.storage.sync.get('labels');
	labels.then((res) => {
		$('.labelButton').each(function(i, obj) {
			if(res.labels.includes(obj.id)){
				$(this).addClass("selected");
			}else{
				$(this).removeClass("selected");
			}
		});
	});
}

document.addEventListener('DOMContentLoaded', restoreOptions);

var labels = browser.storage.sync.get('labels');
labels.then((res) => {
	if(res.labels == null){
		var labels = browser.storage.sync.get('labels');
		labels.then((res) => {
			var labellist = [];
			$('.labelButton').each(function(i, obj) {
				labellist.push(obj.id)
				$(this).addClass("selected");
			});
			browser.storage.sync.set({
				labels: labellist
			}).then(function(){
				updateOptionsContentScript();
			});
		});
	}
});

var censor_type = browser.storage.sync.get('censor_type');
censor_type.then((res) => {
	if(res.censor_type == null){
		browser.storage.sync.set({
			censor_type: 'black'
		}).then(function(){
			updateOptionsContentScript();
		});
	}
});

